/*Ŀ
 ݳ                                                                      
 ݳ Program Name: ARGS.PRG          Copyright: Gallagher Computing Corp. 
 ݳ Date Created: 12/02/93           Language: Clipper 5.0               
 ݳ Time Created: 09:48:54             Author: Kevin S Gallagher         
 ݳ                                                                      
 Ĵ
 ݳ Comments:                                                            
 ݳ This demo shows a few ways to utilize the C routines for getting     
 ݳ command parameters from anywhere in a Clipper application.           
 ݳ There is a section that checks for a password, and if entered wrong  
 ݳ will cause a recursive call to a function, which in turn calls on    
 ݳ errorsys to pop to dos with a unrecoverable 650 error. Abit on the   
 ݳ extreme side Note how ft_parse is used to check to see if either or 
 ݳ '/' '-' are used for command-params eg. /d/f-a or /d /f -a           
 ݳ                                                                      
 
            */


function main
    getparms()
return nil

procedure Getparms()
    eval({||FromNextOne()})
return

procedure FromNextOne()
    local jj     := 0
    local nCount := 0
    local cParms := ""
    local cStr   := ""

    nCount := getargc()
    cStr   := getargv(0)

    ?""
    ?"Program path and name " + cStr
    ?"    Program name only " + subs(cStr,rat("\",cStr)+1)
    ?"                Drive " + left(cStr,1)
    ?""

    if nCount >0
        Protectme()
        for jj := 1 to nCount
            if "/" $ getargv(jj)
                aeval(FT_PARSE(getargv(jj), "/"),{|a| QOut(a)})
            elseif "-" $ getargv(jj)
                aeval(FT_PARSE(getargv(jj), "-"),{|a| QOut(a)})
            else
                ?getargv(jj)
            endif
        next
    else
        ?"No parameters...."
        break
    endif
return

//
// This shows how to protect a program from being accessed
// by unauthorized users. The exit is abit strange thou...
// Proper: C:\>demo /d /f /PASSWORD PondScum /w -r
// Wrong : C:\>demo /d /f /PASSWORD pondscum /w -r
//
static procedure Protectme()
    local i, lOk := .f.
    if getargc() >0
        for i := 1 to getargc()
            if substr(getargv(i),1,9) == "/PASSWORD"
                if getargv(i+1) == "PondScum"
                    lOk := .t.
                endif
            endif
        next
    endif
    ?
    if !lOk
        OpenFiles()
    endif
return

//
// Stack eater
//
function OpenFiles()
    OpenFiles()
return nil

/*
 * File......: FTPARSE.PRG
 * Author....: Gary F. Alderson
 * CIS ID....: INTERNET> Gary_Alderson@UManitoba.CA
 * Date......: $1993-04-10$
 * Revision..: $1.00$
 * Log file..: $Logfile$
 * 
 * This is an original work by [Gary F. Alderson] and is placed in the
 * public domain.
 *
 * Modification history:
 * ---------------------
 *
 * $Log$
 *
 */
FUNCTION FT_PARSE(cString, cDelim)
LOCAL nPtr
LOCAL aToken := {}

cDelim  := IF(cDelim == NIL, " ", cDelim)
cString := ALLTRIM(cString)

WHILE (nPtr := AT(cDelim, cString)) != 0
    AADD(aToken, IF(nPtr > 1, RTRIM(LEFT(cString, nPtr-1)), ""))
    cString := IF(LEN(cString) > nPtr, LTRIM(SUBSTR(cString, nPtr+1)), "")
ENDDO

AADD(aToken, cString)
RETURN(aToken)

